apiVersion: {{ deployment_apivers }}
kind: {{ deployment_kind }}
metadata:
  labels:
{% if do_backups %}
    backups.opsperator.io/driver: postgres
{% if (backups_interval | default('daily')) == 'hourly' %}
    backups.opsperator.io/interval: hourly
    backups.opsperator.io/preferredtime: "{{ backups_hourly_start_minute | default(15)}}"
{% elif (backups_interval | default('daily')) == 'weekly' %}
    backups.opsperator.io/interval: weekly
    backups.opsperator.io/preferredtime: "{{ backups_weekly_start_day | default(0) }}"
{% else %}
    backups.opsperator.io/interval: daily
    backups.opsperator.io/preferredtime: "{{ backups_daily_start_hour | default(2) }}"
{% endif %}
    backups.opsperator.io/secret: {{ postgres_name }}
{% endif %}
{% if pki_set | length > 0 %}
    pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    {{ network_policy_deployment_label }}: {{ postgres_name }}
  name: {{ postgres_name }}
  namespace: {{ namespace }}
spec:
  replicas: {{ postgres_replicas }}
  revisionHistoryLimit: {{ deploy_revision_history_limit | default(10) }}
  selector:
{% if deployment_kind != 'DeploymentConfig' %}
    matchLabels:
      name: {{ postgres_name }}
  strategy:
    type: Recreate
{% else %}
    name: {{ postgres_name }}
  strategy:
    resources:
      limits:
        cpu: {{ deploy_pod_cpu_limit }}
        memory: {{ deploy_pod_memory_limit }}
      requests:
        cpu: {{ deploy_pod_cpu_request }}
        memory: {{ deploy_pod_memory_request }}
    type: Recreate
{% endif %}
  template:
    metadata:
      labels:
        name: {{ postgres_name }}
    spec:
      automountServiceAccountToken: false
      containers:
      - args:
        - -c
        - "shared_buffers={{ postgres_shared_buffers }}"
        - -c
        - "max_connections={{ postgres_max_connections }}"
        env:
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
        - name: PGDATA
          value: /var/lib/postgresql/data/pgdata
        - name: POSTGRES_APP_DB
          valueFrom:
            secretKeyRef:
              key: database-name
              name: {{ postgres_name }}
        - name: POSTGRES_APP_PASSWORD
          valueFrom:
            secretKeyRef:
              key: database-password
              name: {{ postgres_name }}
        - name: POSTGRES_APP_USER
          valueFrom:
            secretKeyRef:
              key: database-user
              name: {{ postgres_name }}
        - name: POSTGRES_DB
          value: postgres
        - name: POSTGRES_PASSWORD
          valueFrom:
            secretKeyRef:
              key: database-admin-password
              name: {{ postgres_name }}
        - name: POSTGRES_USER
          value: postgres
        - name: TZ
          value: {{ timezone }}
{% if do_triggers == False or (opsimages | json_query("[?name=='postgres'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='postgres'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          exec:
            command:
            - /bin/sh
            - -i
            - -c
            - pg_isready -h 127.0.0.1 -p 5432
          failureThreshold: 38
          initialDelaySeconds: 30
          periodSeconds: 15
          timeoutSeconds: 3
        name: postgres
        ports:
        - containerPort: 5432
        readinessProbe:
          exec:
            command:
            - /bin/sh
            - -i
            - -c
            - psql -h 127.0.0.1 -U $POSTGRES_APP_USER -q -d $POSTGRES_APP_DB -c 'SELECT 1'
          initialDelaySeconds: 5
          periodSeconds: 10
          timeoutSeconds: 3
        resources:
          limits:
            cpu: "{{ cpu_limit }}"
            memory: "{{ memory_limit }}"
          requests:
            cpu: "{{ cpu_limit }}"
            memory: "{{ memory_limit }}"
        volumeMounts:
        - mountPath: /docker-entrypoint-initdb.d
          name: custom
        - mountPath: /var/lib/postgresql/data
          name: db
{% if do_exporters %}
      - env:
        - name: DATA_SOURCE_NAME
          valueFrom:
            secretKeyRef:
              key: database-url
              name: {{ postgres_name }}
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
        - name: PG_EXPORTER_WEB_LISTEN_ADDRESS
          value: ":9113"
{% if do_triggers == False or (opsimages | json_query("[?name=='pgexporter'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='pgexporter'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          failureThreshold: 38
          initialDelaySeconds: 30
          periodSeconds: 15
          tcpSocket:
            port: 9113
          timeoutSeconds: 3
        name: exporter
        ports:
        - containerPort: 9113
        resources:
          limits:
            cpu: "{{ exporter_cpu_limit }}"
            memory: "{{ exporter_memory_limit }}"
          requests:
{% if ensure_dbs_has_guaranteed_qosclass | default(True) %}
            cpu: "{{ exporter_cpu_limit }}"
            memory: "{{ exporter_memory_limit }}"
{% else %}
            cpu: "{{ exporter_cpu_request }}"
            memory: "{{ exporter_memory_request }}"
{% endif %}
{% endif %}
{% if k8s_resource_nodes_selectors | length > 0 %}
      nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and ocp_major in [ 4, '4' ]) %}
      priorityClassName: opsperator-database
{% endif %}
{% if k8s_flavor == 'kubernetes' or rwo_needs_fsgroup | default(False) %}
      securityContext:
{% if rwo_needs_fsgroup | default(False) %}
        fsGroup: {{ rwo_needs_fsgroup }}
{% endif %}
{% if k8s_flavor == 'kubernetes' %}
{% if 0 == 1 %}
        runAsUser: 70
#^ using alpine image
{% else %}
        runAsUser: 999
{% endif %}
{% endif %}
{% endif %}
      terminationGracePeriodSeconds: {{ postgres_termination_timeout | default(600) }}
      volumes:
      - configMap:
          name: {{ postgres_name }}
        name: custom
      - name: db
        persistentVolumeClaim:
          claimName: {{ postgres_name }}
{% if (do_triggers | default(False)) %}
  triggers:
{% if (opsimages | json_query("[?name=='postgres'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - postgres
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='postgres'].short"))[0] }}
        namespace: {{ namespace }}
{% endif %}
{% if do_exporters and (opsimages | json_query("[?name=='pgexporter'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - exporter
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='pgexporter'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
  - type: ConfigChange
{% endif %}
